package info.markhillman.ImageViewer;

import javax.imageio.ImageIO;
import javax.swing.*;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import info.markhillman.mwindow.*;

/**
 * Class: ImagePanel
 * Description: This class will draw an image supplied to it
 * by the constructor onto its base JPanel component graphics
 * object
 * Created by Mark on 02/01/2016.
 */
public class ImagePanel extends MPanel {

    private String imagePath;
    private BufferedImage image;

    public ImagePanel(String imagePath) throws IOException {
        super();
        this.imagePath = imagePath;
        image = loadImage(this.imagePath);
        setPreferredSize(new Dimension(image.getWidth(), image.getHeight()));
    }

    //This will create the BufferedImage from the image path
    public BufferedImage loadImage(String imagePath) throws IOException {

        //Create a new BufferedImage
        BufferedImage image = ImageIO.read(new File(imagePath));
        return image;
    }

    //Override the painComponent to draw the BufferedImage
    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);
        g.drawImage(image, 0, 0, null);
    }

    //This will update the image on the JPanel
    public void changeImage(String imagePath) throws IOException {
        image = loadImage(imagePath);
    }
    public void changeImage() throws IOException {
        image = loadImage(this.imagePath);
    }

    //Getters and setters
    public String getImagePath() {
        return imagePath;
    }
    public void setImagePath(String imagePath) {
        this.imagePath = imagePath;
    }
    public BufferedImage getImage() {
        return image;
    }
}
